global MAIN_DICT dash clock

source [file join [file dirname [info script]] "backend_10GBase-KR.tcl"]
source [file join [file dirname [info script]] "backend_40GBase-KR4.tcl"]
source [file join [file dirname [info script]] "define_signals_10GBase-KR.tcl"]
source [file join [file dirname [info script]] "define_signals_40GBase-KR4.tcl"]
# source backend_10GKR.tcl
# source backend_40GKR.tcl
# source define_signals_10GKR.tcl
# source define_signals_40GKR.tcl


#*************************************Start*********************************#
proc main_LA_S10 {GUI input_csv output_csv IPvariant} {
	global MAIN_DICT dash clock
	#
	if {$GUI==1} {
		GUI_tool_init
	} elseif {$GUI==0} {
		#Call respective DEFINE_SIGNALS_XX procudre based on target IP. This procedure erase & recreates the whole MAIN_DICT database. Thats why it is important to execute it before below variable definitions. 
		define_signals_$IPvariant
		dict set MAIN_DICT var.IPtype $IPvariant
		dict set MAIN_DICT var.file_name $input_csv
		dict set MAIN_DICT var.report_name $output_csv
		proceed 0
	}
}

proc proceed {GUI} {
	global MAIN_DICT dash clock
	
	puts "\n******************  NEW CAPTURE  *********************"
	
	#If GUI is enabled, this stores the IP type selected on GUI and then the path of CSV file to be imported
	if {$GUI==1} {
		define_signals_[dashboard_get_property $dash eth_IP_selection selectedItem]
		dict set MAIN_DICT var.IPtype [dashboard_get_property $dash eth_IP_selection selectedItem]
		#Below procedure will also be called from the proc "GUI_tool_init" based on button click. Its imp to call it here again because DEFIME_SIGNALS_xxx procedure erase & recreates the whole MAIN_DICT database 
		GUI_return_csv_file_path	
	}
	open_csv_file
	find_signalname_coordinates $GUI

	if {[dict get $MAIN_DICT var.stall_execution] == 0} {

		#Proc to fill the dictionary (MAIN_DICT) with the sample values of all signals
		fill_dict
		#Proc to find START and STOP time for each sequencer state. Time is extracted from LF timer values: stage_one, stage_two and stage_trey
		find_start_stop_time_of_states_[dict get $MAIN_DICT var.IPtype]
		#Below 3 procedures are for performing all the processing during Auto-Neg, Link raining and Data mode respectively.
		AN_datamining_[dict get $MAIN_DICT var.IPtype]
		LT_datamining_[dict get $MAIN_DICT var.IPtype]
		DATA_mining_[dict get $MAIN_DICT var.IPtype]	
		
		#Once all the processing is done and if GUI is enabled, below procedures are executed. Below procedures take all conclusion from above *datamining* procedures and update them in GUI
		if {$GUI==1} {
			GUI_Sequencer_SM_[dict get $MAIN_DICT var.IPtype]
			GUI_AN_init_[dict get $MAIN_DICT var.IPtype]
			GUI_LT_init_[dict get $MAIN_DICT var.IPtype]
			GUI_DATA_init_[dict get $MAIN_DICT var.IPtype]
			GUI_help_[dict get $MAIN_DICT var.IPtype]
		}		
	} else {
		puts "\nERROR:   Required list of signals could not be found in csv"
	}
	
	if {$GUI==1} {
		GUI_Sequencer_SM_final_update			
	} else {
		generate_report_[dict get $MAIN_DICT var.IPtype] $GUI
	}
	
	close [dict get $MAIN_DICT var.fhandle]
	puts "*************************  END  **************************"
}

proc GUI_tool_init {} {
	global MAIN_DICT dash rep clock
	
	incr rep; 
	set dash [add_service dashboard ETH_DnD$rep "LINK ANALYSIS$rep" "Tools/ETH_DnD"]
	dashboard_set_property $dash self visible true
	widget_group 1 main_group self 1 ""
	
	widget_group 1 main_group_2nd main_group 3 ""	
		
	#Create group for "Import .csv File"	
	widget_group 1 board_connection main_group_2nd 2 "Import .csv File"		
		widget_comboBox 1 eth_IP_selection board_connection "10GBase-KR 40GBase-KR4" find_eth_IP
		dict set MAIN_DICT var.IPtype [dashboard_get_property $dash eth_IP_selection selectedItem]
		
		widget_fileChooserButton 1 file_choose board_connection "Select .csv file" "Select" "Select .csv file" [list "Comma Separated values (.csv)" "csv"] GUI_return_csv_file_path
			
		widget_button 1 run_stp board_connection "Start Analysis" false white black 50 "proceed 1"
		
	#Create group for REPORT GENERATION
	widget_group 1 csv_report main_group_2nd 2 "Report Generation (.csv)"	
		widget_text 1 output_csv_filename csv_report yes "ReportName" 20 150
		widget_label 1 output_csv_label csv_report "Output Filename (put filename without extension)" black
		widget_button 1 create_report csv_report "Generate Report" false white black 50 "generate_report_[dict get $MAIN_DICT var.IPtype] 1"
		
		dict set MAIN_DICT var.file_name ""				
		
	#Create group for "Status Bar"	
	widget_group 1 status_bar main_group_2nd 1 "Status Bar"
		widget_label 1 loaded_csv_file_dir status_bar "File loaded: --" black		
		widget_button 1 processing_status status_bar "Processing NOT started" false white black 150 IDLE		
		
	#Adding "my_tabs" here so that when it is first removed in procedure "GUI_Sequencer_SM", there is no NULL error.
	#"my_tabs" is a tabbedgroup. Whatever is added directly to "mytabs" will be a new tab in main page of tool
	dashboard_add $dash my_tabs tabbedGroup main_group
}

proc GUI_return_csv_file_path {} {
	global MAIN_DICT dash clock
	
	#This reads the path of input csv file from the GUI widget (filechooserButton). 
	dict set MAIN_DICT var.csv_file_path [dashboard_get_property $dash file_choose paths]
	#This is to remember the last used directory 
	dashboard_set_property $dash file_choose paths [dashboard_get_property $dash file_choose paths]
	
	if {![string match [dict get $MAIN_DICT var.csv_file_path] ""]} {
		puts "\nCSV File Path: [dict get $MAIN_DICT var.csv_file_path]\n"
		dict set MAIN_DICT var.file_name [lindex [join [split [dict get $MAIN_DICT var.csv_file_path] \\] /] 0]
		puts "File Selected: [dict get $MAIN_DICT var.file_name]"
		widget_button 0 processing_status board_connection "Processing NOT started" false white black 100 IDLE
		widget_button 0 create_report csv_report "Generate Report" false white black 50 "generate_report_[dict get $MAIN_DICT var.IPtype] 1"
		widget_label 0 loaded_csv_file_dir main_group "File loaded: [dict get $MAIN_DICT var.file_name]" black
		widget_button 0 run_stp board_connection "Start Analysis" true white black 50 "proceed 1"
	} else {
		widget_button 0 run_stp board_connection "Start Analysis" false white black 50 "proceed 1"
	}
}

#
proc GUI_Sequencer_SM_final_update {} {
	global dash MAIN_DICT clock
 
 	if {[dict get $MAIN_DICT var.stall_execution] == 0} {
		widget_button 0 processing_status board_connection "Processing DONE" false green black 100 IDLE
	} elseif {[dict get $MAIN_DICT var.stall_execution] == 1} {
		widget_button 0 processing_status board_connection "Processing ERROR!!!" false red black 100 IDLE
	}
	widget_button 0 create_report csv_report "Generate Report" true white black 50 "generate_report_[dict get $MAIN_DICT var.IPtype] 1"
}	

proc open_csv_file {} {
	global MAIN_DICT dash clock
	
	#dict set MAIN_DICT var.file_name [lindex [join [split [dict get $MAIN_DICT var.csv_file_path] \\] /] 0]
	dict set MAIN_DICT var.fhandle [open [dict get $MAIN_DICT var.file_name] r]
}

proc find_signalname_coordinates {GUI} {
	global MAIN_DICT clock
	set row_no 0
	dict set MAIN_DICT var.stall_execution 0
	
	if {$GUI} {	
		widget_button 0 processing_status board_connection "Processing... Please Wait" false yellow black 100 IDLE	
	}	
	#Keep reading lines from csv until "Data" is found
	while {[gets [dict get $MAIN_DICT var.fhandle] line] > -1} {
		set stuff $line
		incr row_no 
		if ([regexp "^Data:" $stuff match]) {
			puts "Signal names are present in row [expr {$row_no+1}] of .csv file"
			incr row_no
			break
		}  
	}
	if {[gets [dict get $MAIN_DICT var.fhandle] line] > -1} {
		#FOR loop for all the signals to be matched in csv file
		for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SIGNALS]} {incr j} {
			set col_no 0
			set signal_found_in_csv 0
			foreach cell_value [split $line ","] {
				incr col_no
				if {[regexp "[dict get $MAIN_DICT var.signal$j.patMatch]" $cell_value match]} {
					dict set MAIN_DICT var.Xsignal$j $col_no
					dict set MAIN_DICT var.Ysignal$j $row_no
					set signal_found_in_csv 1
					break
				}
			}
			if {$signal_found_in_csv == 1} {
				puts "[dict get $MAIN_DICT var.signal$j] found at ($col_no,$row_no) coordinate of .csv file"
			} else {
				puts "[dict get $MAIN_DICT var.signal$j] NOT found in .csv file"
				dict set MAIN_DICT var.stall_execution 1
			}
		}
	}                              
}

#Based on all the signal coordinates found from procedure "find_signalname_coordinates", this procedure reads the data for every signal and store it in dictionary

proc fill_dict {} {
	global MAIN_DICT clock
	
	puts "** Found required list of signals in csv.  Moving forward..."
	set j 0
	while {[gets [dict get $MAIN_DICT var.fhandle] line] > -1} {
		set full_row [split $line ","]	
		for {set i 1} {$i <= [dict get $MAIN_DICT var.TOTAL_SIGNALS]} {incr i}	{
			dict set MAIN_DICT [dict get $MAIN_DICT var.signal$i].[expr {$j}] [lindex $full_row [expr {[dict get $MAIN_DICT var.Xsignal$i]-1}]]
		} 
		dict set MAIN_DICT var.TOTAL_SAMPLES $j
		incr j
	}
	puts "Total samples for each signal in csv: [dict get $MAIN_DICT var.TOTAL_SAMPLES]"	 
}


proc dec2bin i {
    set res {} 
    while {$i>0} {
        set res [expr {$i%2}]$res
        set i [expr {$i/2}]
    }
    if {$res == {}} {set res 0}
    return $res
}
proc bin2dec bin {
    if {$bin == 0} {
        return 0
    } elseif {[string match -* $bin]} {
        set sign -
        set bin [string range $bin[set bin {}] 1 end]
    } else {
        set sign {}
    }
    return $sign[expr 0b$bin]
}
proc IDLE {} {
}

proc widget_group {add name group itemsPerRow text} {
	global dash
	if {$add} {
		dashboard_add $dash $name group $group
	}
	dashboard_set_property $dash $name itemsPerRow $itemsPerRow
	dashboard_set_property $dash $name title $text
}
proc widget_label {add name group text foregroundColor} {
	global dash
	if {$add} {
		dashboard_add $dash $name label $group
	}
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name foregroundColor $foregroundColor
}
proc widget_led {add name group text color} {
	global dash
	if {$add} {
		dashboard_add $dash $name led $group
	}
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name color $color
}
proc widget_comboBox {add name group options onChange} {
	global dash
	if {$add} {
		dashboard_add $dash $name comboBox $group
	}
	dashboard_set_property $dash $name options $options
	dashboard_set_property $dash $name onChange $onChange
}
proc widget_button {add name group text enabled backgroundColor foregroundColor preferredWidth onClick} {
	global dash
	if {$add} {
		dashboard_add $dash $name button $group
	}
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name enabled $enabled
	dashboard_set_property $dash $name backgroundColor $backgroundColor
	dashboard_set_property $dash $name foregroundColor $foregroundColor
	dashboard_set_property $dash $name preferredWidth $preferredWidth
	dashboard_set_property $dash $name onClick $onClick
}
proc widget_fileChooserButton {add name group text chooserButtonText title filter onChoose} {
	global dash
	if {$add} {
		dashboard_add $dash $name fileChooserButton $group
	}
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name chooserButtonText $chooserButtonText
	dashboard_set_property $dash $name title $title
	dashboard_set_property $dash $name filter $filter
	dashboard_set_property $dash $name onChoose $onChoose	
}
proc widget_checkBox {add name group text onClick} {
	global dash
	if {$add} {
		dashboard_add $dash $name checkBox $group
	}
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name onClick $onClick
}
proc widget_text {add name group editable text preferredHeight preferredWidth} {
	global dash
	if {$add} {
		dashboard_add $dash $name text $group
	}
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name editable $editable
	dashboard_set_property $dash $name preferredHeight $preferredHeight
	dashboard_set_property $dash $name preferredWidth $preferredWidth
}
proc widget_xyChart {add name group title labelX labelY showLegend preferredHeight preferredWidth range} {
	global dash
	if {$add} {
		dashboard_add $dash $name xyChart $group
	}
	dashboard_set_property $dash $name title $title
	dashboard_set_property $dash $name labelX $labelX
	dashboard_set_property $dash $name labelY $labelY
	dashboard_set_property $dash $name showLegend $showLegend
	dashboard_set_property $dash $name preferredHeight $preferredHeight
	dashboard_set_property $dash $name preferredWidth $preferredWidth
	dashboard_set_property $dash $name range $range
}


proc find_eth_IP {} {
	global MAIN_DICT dash
	
	dict set MAIN_DICT var.IPtype [dashboard_get_property $dash eth_IP_selection selectedItem]
}



#SIGNED 
#proc bin2dec {bitstream} {
    # binary scan [binary format B* [format %032s $bitstream]] I value
    # return $value
# }
#set lftimer [bin2dec [concat [dec2bin $timer1][dec2bin $timer2][dec2bin $timer3]]]
#set lftimer [bin2dec [join [list [dec2bin $timer1][dec2bin $timer2][dec2bin $timer3]]]]

#% scan $hex %x decimal
#1
#% set decimal
#58














